#ifndef SYNTAX_H
#define SYNTAX_H

typedef float num_t;
typedef char* atom_t;
typedef char* string_t;
typedef struct expr_t expr_t;
typedef struct binop_t binop_t;
typedef struct object_t object_t;
typedef struct function_t function_t;
typedef struct block_t block_t;

#define DEE_BINOP 1
#define DEE_ID    2
#define DEE_NUM   3
#define DEE_STR   4
#define DEE_OBJ   5

struct binop_t {
  expr_t *first;
  expr_t *second;
  int op;
};

struct object_t {};

struct expr_t {
  int type;
  union {
    atom_t id;
    num_t num;
    string_t string;
    binop_t binop;
    object_t object;
  };
};

expr_t make_binop(int, expr_t, expr_t);

#endif /* SYNTAX_H */
